/*
 * IPVS:        Round-Robin Scheduling module
 *
 * Version:     $Id: ip_vs_rr.c,v 1.5 1999/10/06 10:04:46 wensong Exp $
 *
 * Authors:     Wensong Zhang <wensong@iinchina.net>
 *              Peter Kese <peter.kese@ijs.si>
 *
 *              This program is free software; you can redistribute it and/or
 *              modify it under the terms of the GNU General Public License
 *              as published by the Free Software Foundation; either version
 *              2 of the License, or (at your option) any later version.
 *
 * Fixes/Changes:
 *     Wensong Zhang            :     changed the ip_vs_rr_schedule to return dest
 *     Julian Anastasov         :     fixed the NULL pointer access bug in debugging
 *     Wensong Zhang            :     changed some comestics things for debugging
 *     Wensong Zhang            :     changed for the d-linked destination list
 *     Wensong Zhang            :     added the ip_vs_rr_update_svc
 *     Wensong Zhang            :     added any dest with weight=0 is quiesced 
 *
 */

#include <linux/config.h>
#include <linux/module.h>
#ifdef CONFIG_KMOD
#include <linux/kmod.h>
#endif
#include <linux/types.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <net/ip_masq.h>
#ifdef CONFIG_IP_MASQUERADE_MOD
#include <net/ip_masq_mod.h>
#endif
#include <linux/sysctl.h>
#include <linux/ip_fw.h>
#include <net/ip_vs.h>
#include <net/ip_cs.h>





int module_rule_matching(struct sk_buff *skb)
{
	
/*	struct iphdr *iph=skb->nh.iph;

	int data_len;
	unsigned char *payload;
	char req_data[5000];
	int i;
	char *xmlPtr="<?xml version=\"1.0\" encoding=\"utf-8\" standalone=\"yes\"?><!--======= The Wrox Press Book Catalog Application =======-->
<Book><Title>Professional XML</Title><Author>Mark Birbeck, Steven Livingstone, Didier Martin, Stephen Mohr, Nikola Ozu, et at.</Author>
<Publisher>Wrox Press, Ltd.</Publisher><PubDate>November 1999</PubDate><Abstract>XML 0-500kmh in 3 seconds</Abstract>
<Pages>750</Pages><ISBN>1-861003-11-0</ISBN><RecSubjCategories><Category>Internet</Category><Category>Web Publishing</Category>
<Category>XML</Category></RecSubjCategories></Book>";
	printk("##############This is a matching module function \n");

	payload=skb->data+iph->ihl*4+skb->h.th->doff*4;
	data_len=skb->len-(iph->ihl*4+skb->h.th->doff*4);

	if(data_len<0)
		return 0;
	
	memset(req_data,0,data_len+1);

	memcpy(req_data,payload,data_len);

	urlresult=url_extract(req_data);
	
	for(i=0;i<tag_num;i++)

	{
		printk("#####xml_tag[%d]=%s\n",i,xml_tag[i]);	
		xmlresult[i]=xmlextract(xmlPtr,xml_tag[i]);
		printk("#############xmlresult[%d]=%s\n",i,xmlresult[i]);
	}  
	
	for(i=0;i<tag_num;i++)

	{
		
		printk("#####xml_tag[%d]=%s\n",i,xml_tag[i]);
		printk("#############XMLRESULT[%d]=%s\n",i,xmlresult[i]);
	}  
	
	return rule_configure(skb,urlresult,NULL);
*/
	return 1;
	
}
/*
void free_mem()
{
	int i;
	kfree(urlresult);

	
}

int route_to(char * server_name, int sticky_flag)

{
	
	int ret;
	printk("######SERVER_NAME=%s\n",server_name);
	if (strcmp(server_name,"ace")){
		printk("###### SERVER_ROUTE_TO=ace\n");
		return 1;
	}
	if (strcmp(server_name,"frodo")){
		printk("###### SERVER_ROUTE_TO=frodo\n");
		return 2;
	}
	if( strcmp(server_name,"default")){
		printk("######SERVER_ROUTE_TO=default\n");
		return 0;
	}
	return 0;
}
*/


void register_rule_matching()

{
	rule_matching=module_rule_matching;
}


void unregister_rule_matching()
{
	int i;
	/*for(i=0;i<tag_num;i++){
	
		
		kfree(xml_tag[i]);
	}*/

	rule_matching=ip_cs_norule;
}



int init_module(void)
{
        printk("#############INSERT MATCHING MODIFIED\n");
	register_rule_matching();

	return 0;
}

void cleanup_module(void)
{
	unregister_rule_matching();
	
 printk("################REMOVED MATCHING MODIFIED\n");
}

